import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../../common";
export interface BasicRoyaltiesInterface extends utils.Interface {
    functions: {
        "royaltyInfo(uint256,uint256)": FunctionFragment;
        "supportsInterface(bytes4)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "royaltyInfo" | "supportsInterface"): FunctionFragment;
    encodeFunctionData(functionFragment: "royaltyInfo", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "supportsInterface", values: [PromiseOrValue<BytesLike>]): string;
    decodeFunctionResult(functionFragment: "royaltyInfo", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "supportsInterface", data: BytesLike): Result;
    events: {
        "DefaultRoyaltySet(address,uint96)": EventFragment;
        "TokenRoyaltySet(uint256,address,uint96)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "DefaultRoyaltySet"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "TokenRoyaltySet"): EventFragment;
}
export interface DefaultRoyaltySetEventObject {
    receiver: string;
    feeNumerator: BigNumber;
}
export declare type DefaultRoyaltySetEvent = TypedEvent<[
    string,
    BigNumber
], DefaultRoyaltySetEventObject>;
export declare type DefaultRoyaltySetEventFilter = TypedEventFilter<DefaultRoyaltySetEvent>;
export interface TokenRoyaltySetEventObject {
    tokenId: BigNumber;
    receiver: string;
    feeNumerator: BigNumber;
}
export declare type TokenRoyaltySetEvent = TypedEvent<[
    BigNumber,
    string,
    BigNumber
], TokenRoyaltySetEventObject>;
export declare type TokenRoyaltySetEventFilter = TypedEventFilter<TokenRoyaltySetEvent>;
export interface BasicRoyalties extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: BasicRoyaltiesInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        royaltyInfo(tokenId: PromiseOrValue<BigNumberish>, salePrice: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[string, BigNumber]>;
        supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<[boolean]>;
    };
    royaltyInfo(tokenId: PromiseOrValue<BigNumberish>, salePrice: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[string, BigNumber]>;
    supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<boolean>;
    callStatic: {
        royaltyInfo(tokenId: PromiseOrValue<BigNumberish>, salePrice: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[string, BigNumber]>;
        supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<boolean>;
    };
    filters: {
        "DefaultRoyaltySet(address,uint96)"(receiver?: PromiseOrValue<string> | null, feeNumerator?: null): DefaultRoyaltySetEventFilter;
        DefaultRoyaltySet(receiver?: PromiseOrValue<string> | null, feeNumerator?: null): DefaultRoyaltySetEventFilter;
        "TokenRoyaltySet(uint256,address,uint96)"(tokenId?: PromiseOrValue<BigNumberish> | null, receiver?: PromiseOrValue<string> | null, feeNumerator?: null): TokenRoyaltySetEventFilter;
        TokenRoyaltySet(tokenId?: PromiseOrValue<BigNumberish> | null, receiver?: PromiseOrValue<string> | null, feeNumerator?: null): TokenRoyaltySetEventFilter;
    };
    estimateGas: {
        royaltyInfo(tokenId: PromiseOrValue<BigNumberish>, salePrice: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        royaltyInfo(tokenId: PromiseOrValue<BigNumberish>, salePrice: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
